# To prepare the trees from the simulation data provided by Villandre et al., do the following:
source("simData_to_trees.R")
prepare_data_tables(list(A_simData,B_simData,C_simData), c("A","B","C"))
# This will save 12 data tables (one per network type and weight scheme) containing the phylogenies

# To perform ML.MSBD inference on each tree call from command line
# Rscript run_ML_inference.R x i j
# where x is the network type (A, B or C), i is the index of the weight scheme (between 1 and 4) and j is the index of the tree (between 1 and 300)

# Once the inference is done it will produce files called job_x_i_j.RData. The clustering analysis can be performed using
source("get_clusters_scores")
dir = "path/to/results/folder" # this folder should contain job files in 3 subfolders A, B and C
datadir = "path/to/simData/folder"
destdir = "path/to/store/results"
cluster_analysis(dir, datadir, destdir, limit =8) # limit is used to exclude small clusters from the analysis

# The peak ranges of threshold based methods can be obtained with the following
source("calculate_peak_range.R")
A_rge = peak_range(A_simData, threshold = 0.75)
B_rge = peak_range(B_simData, threshold = 0.75)
C_rge = peak_range(C_simData, threshold = 0.75)
summary_ranges = peak_summary(A_rge, B_rge, C_rge)