#! Rscript
library(ape)
library(ML.MSBD)
args = commandArgs(T)
cont = NULL
final = paste0("job_",args[1],"_",args[2],"_",args[3],".RData")
if(!file.exists(final)) {
  path = paste0("tmp_",args[1],"_",args[2],"_",args[3],".RData")
  if(file.exists(path)) {
    load(path)
    cont = try(get("saved_state"))
  }
  load(paste0(args[1],"_IS_",args[2],"_data_table.RData"))
  data = get("benchdata")
  result = ML_MSBD(data$tree[[as.numeric(args[3])]],
                   initial_values = c(0.1,1000,100,50), rho_sampling=FALSE, rho=0, stepsize=0.1, sigma=1, 
                   time_mode="mid", saved_state = cont, unique_mu = T, save_path = path, fast_optim =F)
  save(result,file = final)
  print("done")
}
quit()