bwrite = function(table,name=NULL, dir=NULL) {
  if(is.null(name)) {
    name = deparse(substitute(table))
  }
  else { assign(name,table) }
  save(list=c(name),file = paste0("../",name,".RData"))
  if(!is.null(dir)) {
    dir.create(paste0(dir,name))
    t = paste0(dir,name,"/")
  }
  else {
    t = "../beast_data/"
    dir.create(paste0(t,name))
    t = paste0(t,name,"/")
  }
  for(i in 1:length(table)) {
    write.tree(table[[i]]$phylo,file = paste0(t,name,"_",i,".tre")) 
  }
}

fixlm = function() {
  single = F
  lambdas = c(1,7,15,7,15)
  mus = c(1,1,5,5,1)
  if(single) {
    x = sample(lambdas,1)
    y = sample(mus,1)
  } else {
    s = sample(1:length(lambdas),1)
    x = lambdas[s]
    y = mus[s]
  }
  c(x,y)
}

nshifts = function(x) {
  n = length(x)
  s=0
  for(i in 1:n) {
    s = s + length(x[[i]]$record$shifts.edge) -1
  }
  s/n
}

nshifts_internal = function(x) {
  n = length(x)
  s=0
  for(i in 1:n) {
    for(e in x[[i]]$record$shifts.edge) {
      if(e==0) next
      t = x[[i]]$phylo$edge[e,2]
      if(length(which(x[[i]]$phylo$edge[,1]==t))>0) s = s+1
    }
  }
  s/n
}

output_to_csv = function(file, dir) {
  file.remove(file)
  list = list.files(path = dir,full.names = F)
  flag = T
  for(name in list) {
    load(paste0(dir,"/",name))
    n = strsplit(name,split = ".",fixed = T)[[1]]
    if(length(n)==2) n = n[1]
    else n = paste0(n[1],".",n[2])
    var = get(paste0(n,"_an"))
    
    if(!is.null(var$all)) {
      var$params = var$all[[2]]$params
      var$all = NULL
    }

    var$params$lbda_err_tab = NULL
    var$params$mu_err_tab = NULL
    var$ESS$lpb = NULL
    
    var2 = list(var$ESS, var$gamma,var$nstates,var$params,var$brches)
    var = unlist(var2)
    if(flag) {
      write(c("file",names(var)),file,append = T,sep="\t",ncolumns = length(var)+1)
      flag = F
    }
    write(c(name,var),file,append = T,sep="\t",ncolumns = length(var)+1)
  }
}

output_to_file = function(file,data,append=TRUE) {
  sink(file,append=append)
  print(deparse(substitute(data)))
  print(data)
  sink()
}