# update record of states after corresponding phylo has been modified
# warning: drops consecutive shifts on the same edge
update_records = function(res) {
  if(is.null(res)) return(res)
  found = rep(0,length(res$record$shifts.edge))
  
  init = which(res$record$shifts.edge==0)
  if(max(init) > res$phylo$node.states[1]) browser() 
  h = res$phylo$node.states[1]
  found[h] = 1
  res$record$shifts.edge[h]=0
  res$record$shifts.time[h]=0
  all = list(t=res,f=found)
  all = .update_rec(h,res$phylo$edge[1,1],all)
  found = all$f
  res = all$t
  
  for(i in seq(along=found)) {
    j = length(found)+1-i
    if(found[j]==0) {
      res$record$shifts.edge = res$record$shifts.edge[-j]
      res$record$shifts.time = res$record$shifts.time[-j]
      res$record$lambdas = res$record$lambdas[-j]
      res$record$mus = res$record$mu[-j]
    }
  }
  res = .update_states(res)
  res
}

.update_rec = function(previous,x,all) {
  if(all$t$record$shifts.edge[1]!=0) browser()
  desc = which(all$t$phylo$edge[,1]==x) #edge numbers
  if(length(desc)==0) { #tip
    a = all$t$phylo$tip.states[x]
    if(a!=previous) {
      if(a==1) stop()
      all$t$record$shifts.edge[a] = which(all$t$phylo$edge[,2]==x)
      all$f[a] = 1
    }
  }
  else { #singles eliminated previously so 2 descendants
    a = all$t$phylo$node.states[x-length(all$t$phylo$tip.states)]
    news = previous
    if(a!=previous) {
      if(a==1) stop()
      all$t$record$shifts.edge[a] = which(all$t$phylo$edge[,2]==x)
      news = a
      all$f[a] = 1
    }
    all = .update_rec(news,all$t$phylo$edge[desc[1],2],all)
    all = .update_rec(news,all$t$phylo$edge[desc[2],2],all)
  }
  all
}

.update_states = function(tree) {
  ntips = length(tree$phylo$tip.label)
  totalnodes = ntips + tree$phylo$Nnode
  states = rep(1,totalnodes)
  shifts = tree$record$shifts.edge
  
  for(i in 1:length(shifts)) {
    x = shifts[i]
    if(x==0) next   
    desc=tree$phylo$edge[x,2]
    while(length(desc)>0) {
      states[desc[1]]=i
      desc=c(desc,tree$phylo$edge[which(tree$phylo$edge[,1]==desc[1]),2])
      desc=desc[-1]
    }
  }
  tree$phylo$tip.states = states[1:ntips]
  tree$phylo$node.states = states[(ntips+1):totalnodes]
  tree
}