.closest = function(x, vec) {
  m = Inf
  mi = 0
  for(y in vec) {
    if(abs(x-y)<m) {
      mi = y
      m = abs(x-y)
    }
  }
  mi
}

.gamcalc = function(data, tol=0.01) {
  res = list()
  data = data = data[,paste0("rateShiftModel.gamma")]
  res$av = mean(data)
  res$med = median(data)
  res$conf = quantile(data,probs = c(tol/2, 1-tol/2))
  res
}

.get_plot = function(dist,mp) {
  y = c()
  for(i in 1:length(dist$x)) {
    y[i] = sum(mp$cf*dnorm(dist$x[i],mp$mu,mp$std))
  }
  plot(dist$x,y)
  points(dist$x,dist$y,col="red")
}

.inter_prop = function(a,b) {
  if(a[1]<b[1] && a[2]>b[2]) return(1)
  if(a[1]>b[1] && a[2]<b[2]) return(1)
  if(b[1]>a[2] || a[1]>b[2]) return(0)
  if(a[1]<b[1]) {
    x = (a[2]-b[1])/(a[2]-a[1])
    y = (a[2]-b[1])/(b[2]-b[1])
    return(max(x,y))
  }
  if(b[1]<a[1]) {
    x = (b[2]-a[1])/(a[2]-a[1])
    y = (b[2]-a[1])/(b[2]-b[1])
    return(max(x,y))
  }
}

.calculate_discreps = function(tree,recorded,estimated) {
  result = list(est.lbda=0,est.mu=0,rec.lbda=0,rec.mu=0,
                cor.lbda=0,cor.mu=0,rec.cor.lbda=0,rec.cor.mu=0)
  cor = which(estimated$shifts.edge %in% recorded$shifts.edge)
  rec.cor = which(recorded$shifts.edge %in% estimated$shifts.edge)
  times = node.depth.edgelength(tree)
  times = max(times) - times
  
  states = rep(1,length(tree$edge))
  t0 = rep(max(times),length(estimated$shifts.edge))
  for(j in 1:length(estimated$shifts.edge)) {
    if(j==1) next
    e = estimated$shifts.edge[j]
    t0[j] = estimated$shifts.time[j]
    anc = states[e]
    l_anc = .average_rate(estimated$lambdas[anc],estimated$lambda_rates[anc],t0[j],t0[j],t0[anc])
    desc = e
    while(length(desc)>0) {
      states[desc[1]]=j
      desc=c(desc,which(tree$edge[,1]==tree$edge[desc[1],2]))
      desc=desc[-1]
    }
    a= abs(estimated$lambdas[j]-l_anc)/max(l_anc,estimated$lambdas[j])
    if(abs(a)<1e3) result$est.lbda = result$est.lbda + a
    else print(paste("est.lbda",a))
    
    b=abs(estimated$mus[j]-estimated$mus[anc])/max(estimated$mus[anc],estimated$mus[j])
    if(abs(b)<1e3) result$est.mu = result$est.mu + b
    else browser() # print(paste("est.mu",b))
    
    if(j %in% cor) {
      if(abs(a)<1e3) result$cor.lbda = result$cor.lbda + a
      else print(paste("cor.lbda",a))
      if(abs(b)<1e3) result$cor.mu = result$cor.mu + b
      else print(paste("cor.mu",b))
    }
  }
  
  alldesc = .get_desc(tree)
  ntips = length(tree$tip.label)
  st = max(which(recorded$shifts.edge==0))
  states = states = rep(st,length(tree$edge))
  t0 = rep(max(times),length(recorded$shifts.edge))
  for(j in 1:length(recorded$shifts.edge)) {
    e = recorded$shifts.edge[j]
    if(e==0) next
    anc = states[e]
    l_anc = .average_rate(recorded$lambdas[anc],recorded$lambda_rates[anc],t0[j],t0[j],t0[anc])
    desc = e
    while(length(desc)>0) {
      states[desc[1]]=j
      desc=c(desc,which(tree$edge[,1]==tree$edge[desc[1],2]))
      desc=desc[-1]
    }
    a= abs(recorded$lambdas[j]-l_anc)/max(l_anc,recorded$lambdas[j])
    result$rec.lbda = result$rec.lbda + a
    b= abs(recorded$mus[j]-recorded$mus[anc])/max(recorded$mus[anc],recorded$mus[j])
    result$rec.mu = result$rec.mu + b
    if(j %in% rec.cor) {
      if(abs(a)<1e3) result$rec.cor.lbda = result$rec.cor.lbda + a
      else print(paste("rec.cor.lbda",a))
      if(abs(b)<1e3) result$rec.cor.mu = result$rec.cor.mu + b
      else print(paste("rec.cor.mu",b))
    }
  }
  result
}

.weightedlm_f = function(all, rev.time = F) {
  if(rev.time)
    .weightedlm(all$phylo,all$record$shifts.edge,max(node.depth.edgelength(all$phylo))-all$record$shifts.time, all$record$lambdas,all$record$lambda_rates,all$record$mus)
  else
    .weightedlm(all$phylo,all$record$shifts.edge,all$record$shifts.time, all$record$lambdas,all$record$lambda_rates,all$record$mus)
}

.average_rate = function(val0, rate, ts, te, t0) {
  if(rate==0) return(val0)
  if(rate*(ts-te)<1e-10) return(val0*exp(rate*(ts-t0)))
  av = (val0/(rate*(ts-te)))*(exp(rate*(ts-t0))-exp(rate*(te-t0)))
  if(is.na(av)) browser()
  av
}

.weightedlm = function(tree, edges, edgetimes, lambdas, lambda_rates, mus) {
  ntips = length(tree$tip.label)
  totalnodes = ntips + tree$Nnode
  h = which(c(edges,1) > 0)[1] -1
  states = rep(h,length(tree$edge[,1]))
  
  times = node.depth.edgelength(tree)
  times = max(times) - times
  t0 = c(rep(max(times),h), edgetimes[-1:-h])
  
  for(i in 1:length(edges)) {
    e = edges[i]
    if(e==0) next
    
    s = which(edges==e)
    edgee=tree$edge[e,]
    tree$edge.length[e] = times[tree$edge[e,1]] - edgetimes[i]
    tree$edge = rbind(tree$edge,c(totalnodes+1,edgee[2]))
    tree$edge.length = c(tree$edge.length,edgetimes[i] - times[tree$edge[e,2]])
    tree$edge[e,2]=totalnodes+1
    times = c(times, edgetimes[i])
    totalnodes=totalnodes+1
    tree$Nnode=tree$Nnode+1
    
    desc=length(tree$edge[,1])
    while(length(desc)>0) {
      states[desc[1]]=s
      desc=c(desc,which(tree$edge[,1]==tree$edge[desc[1],2]))
      desc=desc[-1]
    }
  }
  if(!is.null(tree$root.edge)) {
    ca = tree$edge[1,1]
    tree$edge=rbind(c(totalnodes+1,ca),tree$edge)
    tree$edge.length = c(tree$root.edge,tree$edge.length)
    states=c(h,states)
  }
  
  summ = 0
  suml = 0
  lbda_edges = c()
  for(i in 1:length(states)) {
    lbd = .average_rate(lambdas[states[i]],lambda_rates[states[i]],times[tree$edge[i,1]],times[tree$edge[i,2]],t0[states[i]])
    lbda_edges[i] = lbd
    if(lbda_edges[i] > 100 && mus[1] == 5) browser()
    summ = summ + tree$edge.length[i]*mus[states[i]]
    suml = suml + tree$edge.length[i]*lbd
    if(is.na(suml)) browser()
  }
  tot = sum(tree$edge.length)
  if(is.na(tot)) browser()
  res = list(lambda = suml/tot, mu = summ/tot, lbda_edges = lbda_edges)
  res
}