#! Rscript
library(ape)
library(ML.MSBD)
args = commandArgs(T)
cont = NULL
name = strsplit(args[1],split=".",fixed=T)[[1]][1]
final = paste0("job_",name,".RData")
if(!file.exists(final)) {
  path = paste0("tmp_",name,".RData")
  if(file.exists(path)) {
    load(path)
    cont = try(get("previous"))
  }
  tree = read.tree(args[1])
  result = ML_MSBD(tree, initial_values = c(0.1,10,1,0.5), rho_sampling=FALSE, rho=0, stepsize=0.1, sigma=1, 
                   time_mode="mid", saved_state = cont, save_path = path, unique_mu = T)
  save(result,file = final)
  print("done")
}
quit()